/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package org.apache.hadoop.thriftfs.api;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.protocol.*;

/**
 * Context options for every request.
 */
public class RequestContext implements TBase<RequestContext._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("RequestContext");

  private static final TField CONF_OPTIONS_FIELD_DESC = new TField("confOptions", TType.MAP, (short)1);

  /**
   * This map turns into a Configuration object in the server and
   * is currently used to construct a UserGroupInformation to
   * authenticate this request.
   */
  public Map<String,String> confOptions;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    /**
     * This map turns into a Configuration object in the server and
     * is currently used to construct a UserGroupInformation to
     * authenticate this request.
     */
    CONF_OPTIONS((short)1, "confOptions");

    private static final Map<Integer, _Fields> byId = new HashMap<Integer, _Fields>();
    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byId.put((int)field._thriftId, field);
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      return byId.get(fieldId);
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments

  public static final Map<_Fields, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new EnumMap<_Fields, FieldMetaData>(_Fields.class) {{
    put(_Fields.CONF_OPTIONS, new FieldMetaData("confOptions", TFieldRequirementType.DEFAULT, 
        new MapMetaData(TType.MAP, 
            new FieldValueMetaData(TType.STRING), 
            new FieldValueMetaData(TType.STRING))));
  }});

  static {
    FieldMetaData.addStructMetaDataMap(RequestContext.class, metaDataMap);
  }

  public RequestContext() {
  }

  public RequestContext(
    Map<String,String> confOptions)
  {
    this();
    this.confOptions = confOptions;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public RequestContext(RequestContext other) {
    if (other.isSetConfOptions()) {
      Map<String,String> __this__confOptions = new HashMap<String,String>();
      for (Map.Entry<String, String> other_element : other.confOptions.entrySet()) {

        String other_element_key = other_element.getKey();
        String other_element_value = other_element.getValue();

        String __this__confOptions_copy_key = other_element_key;

        String __this__confOptions_copy_value = other_element_value;

        __this__confOptions.put(__this__confOptions_copy_key, __this__confOptions_copy_value);
      }
      this.confOptions = __this__confOptions;
    }
  }

  public RequestContext deepCopy() {
    return new RequestContext(this);
  }

  @Deprecated
  public RequestContext clone() {
    return new RequestContext(this);
  }

  public int getConfOptionsSize() {
    return (this.confOptions == null) ? 0 : this.confOptions.size();
  }

  public void putToConfOptions(String key, String val) {
    if (this.confOptions == null) {
      this.confOptions = new HashMap<String,String>();
    }
    this.confOptions.put(key, val);
  }

  /**
   * This map turns into a Configuration object in the server and
   * is currently used to construct a UserGroupInformation to
   * authenticate this request.
   */
  public Map<String,String> getConfOptions() {
    return this.confOptions;
  }

  /**
   * This map turns into a Configuration object in the server and
   * is currently used to construct a UserGroupInformation to
   * authenticate this request.
   */
  public RequestContext setConfOptions(Map<String,String> confOptions) {
    this.confOptions = confOptions;
    return this;
  }

  public void unsetConfOptions() {
    this.confOptions = null;
  }

  /** Returns true if field confOptions is set (has been asigned a value) and false otherwise */
  public boolean isSetConfOptions() {
    return this.confOptions != null;
  }

  public void setConfOptionsIsSet(boolean value) {
    if (!value) {
      this.confOptions = null;
    }
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case CONF_OPTIONS:
      if (value == null) {
        unsetConfOptions();
      } else {
        setConfOptions((Map<String,String>)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case CONF_OPTIONS:
      return getConfOptions();

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case CONF_OPTIONS:
      return isSetConfOptions();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof RequestContext)
      return this.equals((RequestContext)that);
    return false;
  }

  public boolean equals(RequestContext that) {
    if (that == null)
      return false;

    boolean this_present_confOptions = true && this.isSetConfOptions();
    boolean that_present_confOptions = true && that.isSetConfOptions();
    if (this_present_confOptions || that_present_confOptions) {
      if (!(this_present_confOptions && that_present_confOptions))
        return false;
      if (!this.confOptions.equals(that.confOptions))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      _Fields fieldId = _Fields.findByThriftId(field.id);
      if (fieldId == null) {
        TProtocolUtil.skip(iprot, field.type);
      } else {
        switch (fieldId) {
          case CONF_OPTIONS:
            if (field.type == TType.MAP) {
              {
                TMap _map4 = iprot.readMapBegin();
                this.confOptions = new HashMap<String,String>(2*_map4.size);
                for (int _i5 = 0; _i5 < _map4.size; ++_i5)
                {
                  String _key6;
                  String _val7;
                  _key6 = iprot.readString();
                  _val7 = iprot.readString();
                  this.confOptions.put(_key6, _val7);
                }
                iprot.readMapEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
        }
        iprot.readFieldEnd();
      }
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.confOptions != null) {
      oprot.writeFieldBegin(CONF_OPTIONS_FIELD_DESC);
      {
        oprot.writeMapBegin(new TMap(TType.STRING, TType.STRING, this.confOptions.size()));
        for (Map.Entry<String, String> _iter8 : this.confOptions.entrySet())
        {
          oprot.writeString(_iter8.getKey());
          oprot.writeString(_iter8.getValue());
        }
        oprot.writeMapEnd();
      }
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("RequestContext(");
    boolean first = true;

    sb.append("confOptions:");
    if (this.confOptions == null) {
      sb.append("null");
    } else {
      sb.append(this.confOptions);
    }
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
  }

}

